# 组件特性1

- order: 0

简单的文档描述

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import {View,Text,Icon,SearchBar,Badge,Slider,Link,Image,RefreshControl,ListView} from 'nuke';
import Flex from 'nuke-flex';


let App = class NukeDemoIndex extends Component {
    constructor() {
        super();

        this.state = {
            value:'',
            data:[{},{},{},{},{}],
            isRefreshing: false,
            showLoading:true,
            refreshText: '↓ 下拉刷新',
            hasNext: true,
            showFooter: false
        }

        this.search = this.search.bind(this);
        this.handleLoadMore = this.handleLoadMore.bind(this);
        this.handleRefresh = this.handleRefresh.bind(this);
        this.renderHeader = this.renderHeader.bind(this);
        this.renderFooter = this.renderFooter.bind(this);
        this.renderItem = this.renderItem.bind(this);
        this.page = 1;
    }

    search (data,e) {
        this.setState({
            value: data.value,
        });
    }

  /**
   * 渲染头部
   * @returns {XML}
   */
  renderHeader() {
    return (
      <RefreshControl style={styles.refresh} refreshing={this.state.isRefreshing} onRefresh={this.handleRefresh}>
        <Text style={styles.refreshText}>{this.state.refreshText}</Text>
      </RefreshControl>
    );
  }

  /**
   * 渲染尾部
   * @returns {*}
   */
  renderFooter() {
    if (this.state.hasNext) {
      return (
        <View style={[styles.footerLoading]}><Image src={'//img.alicdn.com/tfs/TB1jZUQRXXXXXcpXpXXXXXXXXXX-100-100.gif?getAvatar=avatar'} style={{width: 100, height: 100}}/></View>
      );
    } else if (this.state.showFooter) {
      return (<View style={[styles.footerLoading]}><Text style={styles.loadingFooterText}>没有了~</Text></View>);
    }
    return null;
  }

    handleLoadMore() {
      this.page = this.page + 1;

      if (this.page>5){
                        this.setState({hasNext: false,showFooter:true});
      }else{
                // 模拟慢速网络
                setTimeout(() => {
                        this.setState({data: this.state.data.concat([{},{}])});
                }, 2000);
      }
    }

  handleRefresh() {
    this.setState({
      isRefreshing: true,
      refreshText: '加载中'
    });

    this.page=1;

          // 模拟慢速网络
          setTimeout(() => {
            this.setState({
              data: [{},{},{},{},{}],
              refreshText: '↓ 下拉刷新',
              isRefreshing: false
            });
          }, 2000);
  }

    renderItem() {
        return (
        <Link href="//detail.m.tmall.com/item.htm?id=541152068663&abtest=12&rn=29566a189b84f0b34289eb948cafb485&sid=53155b01856a508a210bd659cab0850f" style={{display:'initial'}}>
            <Flex style={styles.product}>
                        <Flex.Item flex={1} style={{justifyContent:'center',alignItems:'center'}}>
                            <Image style={styles.imageContainter} src="//gw3.alicdn.com/bao/uploaded/i1/2928278102/TB1ZrlZSVXXXXcIXVXXXXXXXXXX_!!0-item_pic.jpg_210x210.jpg" style={{quality:'original',width:'220rem',height:'220rem'}} />
                        </Flex.Item>
                        <Flex.Item flex={2}>
                            <Text style={styles.title}>券减30+礼】汇仁牌肾宝片126片成人口服 肾亏虚补肾肾虚男补亏损 券减30+礼】汇仁牌肾宝片126片成人口服 肾亏虚补肾肾虚男补亏损</Text>
                            <Text style={styles.price}>¥322</Text>
                            <Flex>
                                <Flex.Item flex={1}>
                                    <Text style={styles.shipping}>免运费</Text>
                                </Flex.Item>
                                <Flex.Item flex={1} style={{alignItems:'center'}}>
                                    <Text style={styles.shipping}>18284人付款</Text>
                                </Flex.Item>
                                <Flex.Item flex={1} style={{alignItems:'flex-end'}}>
                                    <Text style={styles.shipping}>广州</Text>
                                </Flex.Item>
                            </Flex>
                        </Flex.Item>
                    </Flex>
                    </Link>
        );
      }

    render() {
        return (
            <View style={styles.containter}>
                <SearchBar style={styles.searchbarwrap} onSearch={this.search} placeholder="输入搜索关键词" />
<Slider width="750rem" height="235rem"
                       autoplay="false"
                       showsPagination="true"
                       loop="true"
                       index={2}
                       autoplayTimeout="3000"
                       paginationStyle={slideStyle.paginationStyle}>
                       <View style={slideStyle.step1}>
                            <Link target="_blank" href="//market.m.taobao.com/markets/promotion/cxxll?scm=2027.1007_12948_85040_100200300000000_84900_1_97565_11945.11945.11904&item_id=536245233996&activity_id=97565&spm=a215s.7406091.1.home-1-5-1&locate=home-1-5-1"><Image resizeMode={'contain'} style={{quality:'original',width:'750rem',height:'235rem'}} src={'//gw.alicdn.com/imgextra/i1/16/TB2Y_UpXsiEJuJjy1XbXXaizFXa_!!16-0-luban.jpg_q50.jpg'} /></Link>
                       </View>
                       <View style={slideStyle.step2}>
                            <Link target="_blank" href="//pages.tmall.com/wow/act/17929/1?wh_weex=true&scm=2027.1007_12948_85040_100200300000000_84900_6_99954_12248.12248.12237&item_id=43026692399&activity_id=99954&spm=a215s.7406091.1.home-1-5-6&locate=home-1-5-6"><Image resizeMode={'contain'} style={{quality:'original',width:'750rem',height:'235rem'}} src={'//aecpm.alicdn.com/simba/img/TB1CWf9KpXXXXbuXpXXSutbFXXX.jpg_q50.jpg'} /></Link>
                        </View>
                       <View style={slideStyle.step3}>
                            <Link target="_blank" href="//market.m.taobao.com/markets/promotion/cxxll?scm=2027.1007_12948_85040_100200300000000_84900_1_97565_11945.11945.11904&item_id=536245233996&activity_id=97565&spm=a215s.7406091.1.home-1-5-1&locate=home-1-5-1"><Image resizeMode={'contain'} style={{quality:'original',width:'750rem',height:'235rem'}} src={'//gw.alicdn.com/imgextra/i1/71/TB2mFbYXbUOJuJjSZPfXXaSqXXa_!!71-0-luban.jpg_q50.jpg'} /></Link>
                        </View>
                     </Slider>
                <Text style={styles.body}>{this.state.value}</Text>

                            <Flex style={styles.footerContainter2}>
                                                    <Flex.Item style={styles.footItem}>
                                                        <Icon style={styles.footIcon} name={'email'} />
                                                        <Text style={styles.footText}>待付款</Text>
                                                    </Flex.Item>
                                                    <Flex.Item>
                                                        <Icon style={styles.footIcon} name={'display'} />
                                                        <Text style={styles.footText}>代发货</Text>
                                                    </Flex.Item>
                                                    <Flex.Item>
                                                        <Icon style={styles.footIcon} name={'favoritesFilling'} />
                                                        <Text style={styles.footText}>待收货</Text>
                                                    </Flex.Item>
                                                    <Flex.Item>
                                                        <Icon style={styles.footIcon} name={'account'} />
                                                        <Text style={styles.footText}>待评价</Text>
                                                        <Badge style={{position:'absolute',top:'0',right:'0',backgroundColor:'#ff6600'}} count="1" />
                                                    </Flex.Item>
                                                    <Flex.Item>
                                                        <Icon style={styles.footIcon} name={'navMore'} />
                                                        <Text style={styles.footText}>退款/售后</Text>
                                                    </Flex.Item>
                                                </Flex>



                <ListView renderRow={this.renderItem}
                renderHeader={this.renderHeader}
                renderFooter={this.renderFooter}
                onEndReached={this.handleLoadMore}
                dataSource={this.state.data}/>
                <Flex style={styles.footerContainter}>
                    <Flex.Item style={styles.footItem}>
                        <Icon style={styles.footIcon} name={'email'} />
                        <Text style={styles.footText}>首页</Text>
                    </Flex.Item>
                    <Flex.Item>
                        <Icon style={styles.footIcon} name={'display'} />
                        <Text style={styles.footText}>物流</Text>
                    </Flex.Item>
                    <Flex.Item>
                        <Icon style={styles.footIcon} name={'favoritesFilling'} />
                        <Text style={styles.footText}>购物车</Text>
                    </Flex.Item>
                    <Flex.Item>
                        <Icon style={styles.footIcon} name={'account'} />
                        <Text style={styles.footText}>我的淘宝</Text>
                    </Flex.Item>
                    <Flex.Item>
                        <Icon style={styles.footIcon} name={'navMore'} />
                        <Text style={styles.footText}>更多</Text>
                    </Flex.Item>
                </Flex>
            </View>
        );
    }
}

const styles = {
    containter:{
      flex: 1
    },
    searchbarwrap:{
        backgroundColor:'#EBECF0',
    },
    body:{
        fontSize:'32rem',
        color: '#333333',
    },
    footerContainter:{
        borderTopWidth:'1rem',
        borderTopColor:'#EBECF0'
    },
    footerContainter2:{
        borderBottomWidth:'1rem',
        borderBottomColor:'#EBECF0'
    },
    footItem:{
        paddingTop:'10rem',
        paddingBottom:'10rem'
    },
    footIcon:{
        color: '#5D656B',
        fontSize:'22rem',
        textAlign:'center'
    },
    footText:{
        fontSize:'20rem',
        color: '#5D656B',
        height:'40rem',
        lineHeight:'40rem',
        textAlign:'center'
    },
    imageContainter:{
        width:'220rem',
        height:'220rem',
        overflow:'hidden'
    },
    title:{
        height:'88rem',
        lineHeight: '44rem',
        marginBottom: '6rem',
        color: '#4b566a',
        overflow: 'hidden'
    },
    price:{
        color:'#eb5211',
        fontSize:'32rem'
    },
    shipping:{
        color:'#999999',
        fontSize:'24rem',
    },
    product:{
        paddingTop:'24rem',
        paddingBottom:'24rem',
        paddingLeft:'12rem',
        paddingRight:'12rem',
        borderBottomWidth:'1rem',
        borderBottomColor:'#EBECF0'
    },
    refresh:{
        height:"80rem",
        width:"750rem",

        backgroundColor:"#cccccc",
        justifyContent:"center",
        alignItems:"center"
    },
    footerLoading:{
        height:"100rem",
        display:"flex",
        flexDirection:"row",
        alignItems:"center",
        justifyContent:"center"
    },
    loadingFooterText:{
        color:"#666666"
    }
}

var slideStyle={
    step1:{
        width: '750rem',
        height: '235rem',
      },

    step2:{
        width: '750rem',
        height: '235rem',
      },

    step3:{
        width: '750rem',
        height: '235rem',
      },
    paginationStyle:{
        position: 'absolute',
        width: '750rem',
        height: '30rem',
        top : '200rem',
        itemSize:14,
        itemColor: '#ffffff',
        itemSelectedColor: 'rgb(255, 102, 0)'
    }
}

render(<App/>);

````
